import { NgModule } from '@angular/core';

import { BrowserModule } from '@angular/platform-browser';
import { BrowserAnimationsModule } from '@angular/platform-browser/animations';

import { HttpClientModule } from '@angular/common/http';

import { AppRoutingModule } from './app-routing.module';
import { AppStoreModule } from './app-store.module';
import { MaterialModule } from './commons/ui/material/material.module';
import { CovalentModule } from './commons/ui/covalent/covalent.module';

import { AppComponent } from './app.component';

import { RESTService } from './commons/service/rest.service';
import { RPCService } from './commons/service/rpc.service';

@NgModule({
  declarations: [
    AppComponent,
  ],
  imports: [
    BrowserModule,
    BrowserAnimationsModule,
    AppRoutingModule,
    AppStoreModule,
    MaterialModule,
    CovalentModule,
    HttpClientModule,
  ],
  providers: [
    RESTService, RPCService,
  ],
  bootstrap: [AppComponent]
})
export class AppModule { }
