import { Injectable } from '@angular/core';
import { Observable } from 'rxjs/Observable';

import { RxWebsocketSubject } from 'app/core/rx/websocket/rx-websocket-subject';
import { RPCRegistry } from 'app/core/rpc/registry/rpc-registry';


@Injectable()
export class RPCService {
  private wsSocketSubject: RxWebsocketSubject<Object>;
  private rpcRegistry: RPCRegistry;

  constructor() {
    this.wsSocketSubject = new RxWebsocketSubject<Object>('ws://127.0.0.1:19090/webapp');
  }

  public connect(): void {
    this.wsSocketSubject.connect();
    this.wsSocketSubject.subscribe(
      (value: Object) => {
        this.onMessage(value);
      },
      (error: any) => {
        this.onError(error);
      },
      () => {
        this.onDisconnected();
      }
    );
  }

  public call<T>(method: string, ...args: any[]): Observable<T> {
    return undefined;
  }

  public callTimeout<T>(method: string, ...args: any[]): Observable<T> {
    return undefined;
  }

  public send(method: string, ...args: any[]): void {

  }

  private sendInternal(data: Object): void {
    this.wsSocketSubject.next(data);
  }

  public getConnectionStatus(): Observable<boolean> {
    return this.wsSocketSubject.connectionStatus;
  }

  private onMessage(message: Object): void {
    //
    console.log(message);
  }

  private onError(error: any): void {
    //
    console.log(error);
  }

  private onDisconnected(): void {
    //
    console.log('disconnected');
  }
}
