import { Injectable } from '@angular/core';
import { Observable } from 'rxjs/Observable';

import 'rxjs/add/operator/map';

import { RESTService } from 'app/commons/service/rest.service';

import { Member } from '../model/member';

@Injectable()
export class MemberService {

  public constructor(
    private restService: RESTService,
  ) {

  }

  public signin(email: string, password: string): Observable<Member> {
    return this.restService.post('/member/signin', '').map((member: Member) => member);
  }

  public signup(member: Member): Observable<Member> {
    return this.restService.post('/member/signup', '').map((_member: Member) => _member);
  }
}
