import { Action } from '@ngrx/store';

import { Member } from '../../model/member';

export enum ActionType {
  Signin = '[member.auth] Signin',
  SigninSuccess = '[member.auth] SigninSuccess',
  SigninFailure = '[member.auth] SigninFailure',
  SigninRedirect = '[member.auth] SigninRedirect',
  Signout = '[member.auth] Signout',
  SignoutSuccess = '[member.auth] SignoutSuccess',
  SignoutFailure = '[member.auth] SignoutFailure',
}

export class Signin implements Action {
  readonly type = ActionType.Signin;

  constructor(public payload: {email: string, password: string}) {}
}

export class SigninSuccess implements Action {
  readonly type = ActionType.SigninSuccess;

  constructor(public payload: Member) {}
}

export class SigninFailure implements Action {
  readonly type = ActionType.SigninFailure;

  constructor(public payload: any) {}
}

export class SigninRedirect implements Action {
  readonly type = ActionType.SigninRedirect;
}

export class Signout implements Action {
  readonly type = ActionType.Signout;
}

export class SignoutSuccess implements Action {
  readonly type = ActionType.SignoutSuccess;
}

export class SignoutFailure implements Action {
  readonly type = ActionType.SignoutFailure;

  constructor(public payload: any) {}
}

export type Actions =
  | Signin
  | SigninSuccess
  | SigninFailure
  | SigninRedirect
  | Signout
  | SignoutSuccess
  | SignoutFailure
;
