import {
  Actions,
  ActionType,
} from './auth.action';

import {
  State,
  initialState,
} from './auth.state';

import { Member } from '../../model/member';

export function reducer(state = initialState, action: Actions): State {
  switch (action.type) {
    case ActionType.Signin: {
      return {
        ...state,
        error: null,
        isPending: true,
      };
    }

    case ActionType.SigninSuccess: {
      return {
        ...state,
        isSignin: true,
        error: null,
        isPending: false,
        member: action.payload,
      };
    }

    case ActionType.SigninFailure: {
      return {
        ...state,
        isSignin: false,
        error: action.payload,
        isPending: false,
        member: null,
      };
    }

    case ActionType.Signout: {
      return {
        ...state,
        error: null,
        isPending: true,
      };
    }

    case ActionType.SigninSuccess: {
      return {
        ...state,
        isSignin: false,
        error: null,
        isPending: false,
        member: null,
      };
    }

    case ActionType.SigninFailure: {
      return {
        ...state,
        error: action.payload,
        isPending: false,
      };
    }

    default: {
      return state;
    }
  }
}
