import { Member } from '../../model/member';

export interface State {
  isSignin: boolean;
  error: string | null;
  isPending: boolean;
  member: Member | null;
}

export const initialState: State = {
  isSignin: false,
  error: null,
  isPending: false,
  member: null,
};

export const isSignin = (state: State) => state.isSignin;
export const getMember = (state: State) => state.member;
export const getError = (state: State) => state.error;
export const isPending = (state: State) => state.isPending;
